-- Installer script v0.4 by MSI --

try destroyDialog sr_installer Catch()
rollout sr_installer "SolidRocks 2.2.4 Setup" width:210 height:60
(
	local isAdmin = true
	local oldmax = (MaxVersion())[1]<15000
	local maxroot = symbolicPaths.getPathValue "$max"+"\\"
	local macroscripts = if oldmax then symbolicPaths.getPathValue "$macroScripts"+"\\" else maxroot+"MacroScripts\\"
	local maxUI = if oldmax then symbolicPaths.getPathValue "$ui"+"\\" else symbolicPaths.getPathValue "$ui_ln"+"\\"	
	local tempdir = getFilenamePath (getSourceFileName())
	local tobat = #()

	label lbl1 "Select an option:" pos:[5,5] width:200 height:13
	button install1 "Install" pos:[5,25] width:120 height:30 toolTip:("Install to the \""+macroscripts+"\"") across:2
	button uninstall "Uninstall" pos:[130,25] width:75 height:30

	fn delDir DirPath a:false = (
		if doesFileExist dirPath do (
			command = "RD /S /Q \""+dirPath+"\""
			if isAdmin or a then HiddenDOSCommand command startpath:".\\" else append tobat command
		)
	)
	fn delFile filePath = (
		if doesFileExist filePath do (
			if isAdmin then deleteFile filePath else append tobat ("DEL \""+filePath+"\" /Q /F")
		)
	)
	fn delIcons filePatt = (
		for i in (getFiles (maxUI+"Icons\\"+filePatt))+(getFiles (maxUI+"IconsDark\\"+filePatt)) do delFile i
	)
	fn copyDir sourceDir destDir = (
		command = "XCOPY \""+sourceDir+"*\" \""+destDir+"\" /Q /I /S /Y"	
		if isAdmin then HiddenDOSCommand command startpath:".\\" else append tobat command
	)
	fn copyFileA sourceFile destFile = (
		command = "XCOPY \""+sourceFile+"\" \""+(getFilenamePath destFile)+"\" /Q /I /Y"
		if isAdmin then copyFile (sourceFile) (destFile) else append tobat command
	)
	fn copyIcons sourcePatt = (
		for i in (getFiles sourcePatt) do (
			copyFileA i (maxUI+"Icons\\"+(filenameFromPath i))
			if not oldmax do copyFileA i (maxUI+"IconsDark\\"+(filenameFromPath i)) )
	)
	fn editMacro filePath str1 str2= (
		File = dotNetClass "System.IO.File"
		fs = (DotNetObject "System.String" (File.ReadAllText(filePath))).Replace str1 str2
		File.WriteAllText filePath fs
	)
	fn uninst = (
		if ::SRmainpanel != undefined and ::SRmainpanel.indialog do DestroyDialog SRMainPanel
		delDir (maxroot+"solidrocks")
		delFile (maxroot+"SR_FlyWiz_18.mse")
		delFile (maxroot+"SR_MOAWiz_13.mse")
		delFile (maxroot+"SRAnimGlobals.mse")
		delFile (macroscripts+"SolidRocks.mse")
		delFile (macroscripts+"SR_Render.mcr")
		delFile (macroscripts+"SolidRocks.mcr")
		delFile (macroscripts+"SolidRocks_2013.mcr")
		delIcons "SR_icon*"
	)
	fn checkuninst = (
		if doesFileExist(maxroot+"solidrocks") or doesFileExist(macroscripts+"SolidRocks.mse") then (
			if qb = queryBox "You have the SolidRocks installed.  Do you want to uninstall it first?" title: "Warning" do uninst()
			qb
		) else true	
	)
	fn isUserAdmin = (
		local ident = (DotNetClass "System.Security.Principal.WindowsIdentity").GetCurrent()
		local role = (DotNetClass "System.Security.Principal.WindowsBuiltInRole").Administrator
		isAdmin = (DotNetObject "System.Security.Principal.WindowsPrincipal" ident).IsInRole(role)
	)
	fn RunAsAdmin = (
		success=true
		if tobat.count != 0 then (
			batName = (tempdir+"batfile.bat")
			if doesFileExist batName then deleteFile batName
			batFile = createFile batName
			for i in tobat do format "%\n" i to:batFile
			close batFile
			procInfo = dotNetObject "System.Diagnostics.ProcessStartInfo" batName
			procInfo.WindowStyle = (dotNetClass "System.Diagnostics.ProcessWindowStyle").Hidden
			procInfo.Verb = "runas"
			try (
				proc = (dotNetClass "System.Diagnostics.Process").start procInfo
				setWaitCursor()
				proc.WaitForExit()
				proc.Close
			)Catch(
				success=false
				lbl1.text="Aborted!"
				MessageBox "Process is not completed properly!\nTry again."
			)
			tobat = #()
			success
		) else success
	)
	
	on sr_installer open do (
		isUserAdmin()
	)
	on install1 pressed do (
		if checkuninst() do (
			lbl1.text="Started..."
			setWaitCursor()
			if oldmax do editMacro (tempdir+"macroscripts\\SolidRocks.mcr") "maxroot" "UI"
			copyDir (tempdir+"maxroot\\") maxroot
			copyDir (tempdir+"macroscripts\\") macroscripts
			copyIcons (tempdir+"icons\\SR_icon*")
			if RunAsAdmin() do (
				lbl1.text="Installed successfully."
				colorman.reInitIcons()
				try ( filein (macroscripts+"SolidRocks.mcr"); filein (macroscripts+"SR_Render.mcr") ) Catch()
				if queryBox "Installation complete!\n\nGo to Customize -> Customize User Interface, choose \"Subburb Tools\" in the Category list and assign the scripts wherever you want.\n\nOpen the Customize User Interface dialog now?" title: "SolidRocks" do actionMan.executeAction 0 "59226"
			)
		)
	)
	on uninstall pressed do (
		if queryBox "Are you sure?" title: "Uninstall!" do (
			lbl1.text="Started..."
			setWaitCursor()
			uninst()
			if RunAsAdmin() do (
				lbl1.text="Uninstalled successfully."	
				colorman.reInitIcons()
			)
		)
	)
	on sr_installer close do (
		if tempdir == symbolicPaths.getPathValue "$temp"+"\\SR\\" do delDir tempdir a:true
		sr_installer = undefined
		gc()
	)
)
createDialog sr_installer style:#(#style_toolwindow, #style_border, #style_sysmenu)